zoukankan      html  css  js  c++  java
  • hdu 1024 Max Sum Plus Plus(m段最大和)

    Problem Description
    Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

    Given a consecutive number sequence S1, S2, S3, S4 ... Sx, ... Sn (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ Sx ≤ 32767). We define a function sum(i, j) = Si + ... + Sj (1 ≤ i ≤ j ≤ n).

    Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i1, j1) + sum(i2, j2) + sum(i3, j3) + ... + sum(im, jm) maximal (ix ≤ iy ≤ jx or ix ≤ jy ≤ jx is not allowed).

    But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(ix, jx)(1 ≤ x ≤ m) instead. ^_^
     
    Input
    Each test case will begin with two integers m and n, followed by n integers S1, S2, S3 ... Sn.
    Process to the end of file.
     
    Output
    Output the maximal summation described above in one line.
     
    Sample Input
    1 3 1 2 3
    2 6 -1 4 -2 3 -2 3
     
    Sample Output
    6
    8
    思路:
    状态dp[i][j]
    有前j个数,组成i组的和的最大值。
    决策: 第j个数,是在第包含在第i组里面,还是自己独立成组。
    方程 dp[i][j]=Max(dp[i][j-1]+a[j] , max( dp[i-1][k] ) + a[j] ) 0<k<j
    空间复杂度,m未知,n<=1000000,  继续滚动数组。
    时间复杂度 n^3. n<=1000000.  显然会超时,继续优化。
    max( dp[i-1][k] ) 就是上一组 0....j-1 的最大值。我们可以在每次计算dp[i][j]的时候记录下前j个
    的最大值 用数组保存下来  下次计算的时候可以用,这样时间复杂度为 n^2.
    #include <cstdio>
    #include <map>
    #include <iostream>
    #include<cstring>
    #include<bits/stdc++.h>
    #define ll long long int
    #define M 6
    using namespace std;
    inline ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
    inline ll lcm(ll a,ll b){return a/gcd(a,b)*b;}
    int moth[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
    int dir[4][2]={1,0 ,0,1 ,-1,0 ,0,-1};
    int dirs[8][2]={1,0 ,0,1 ,-1,0 ,0,-1, -1,-1 ,-1,1 ,1,-1 ,1,1};
    const int inf=0x3f3f3f3f;
    const ll mod=1e9+7;
    int m,n;
    int a[1000007];
    int dp1[1000007];
    int dp2[1000007];
    int main(){
        //ios::sync_with_stdio(false);
        while(~scanf("%d%d",&m,&n)){
            memset(dp1,0,sizeof(dp1));
            memset(dp2,0,sizeof(dp2));
            for(int i=1;i<=n;i++)
                scanf("%d",&a[i]);
            int maxn;
            for(int i=1;i<=m;i++){ //枚举子序列
                maxn=-inf;
                for(int j=i;j<=n;j++){ //j = i是因为每个子序列最少1个元素
                    dp1[j]=max(dp2[j-1]+a[j],dp1[j-1]+a[j]);
                    dp2[j-1]=maxn;
                    maxn=max(maxn,dp1[j]);
                }    
            }
            cout<<maxn<<endl;    
        }
    }
  • 相关阅读:
    20175314 《Java程序设计》第六周学习总结
    20175314 结队编程项目——四则运算第一周
    20175314 《Java程序设计》迭代和JDB
    20175314 实验一 Java开发环境的熟悉
    20175314 《Java程序设计》第五周学习总结
    20175314 《Java程序设计》第四周学习总结
    20175314 《Java程序设计》第三周学习总结
    20175314 《Java程序设计》第二周学习总结
    20175314 《Java程序设计》第一周学习总结
    多态的成员特点
  • 原文地址:https://www.cnblogs.com/wmj6/p/10395813.html
Copyright © 2011-2022 走看看